#include <SPI.h>      
#include <MFRC522.h>      
#include <LiquidCrystal_I2C.h>
#include <Servo.h>

LiquidCrystal_I2C lcd(0x27,16,2);

Servo servo;

#define RST_PIN  9      
#define SS_PIN  10      

MFRC522 mfrc522(SS_PIN, RST_PIN); 
byte LecturaUID[4];         
byte Usuario2[4]= {0x79, 0x3D, 0x05, 0xA4} ;    
byte Usuario1[4]= {0x77, 0x2B, 0x40, 0x63} ;    
int red = 7;
int green = 6;
int blue = 5;
void setup() {

  lcd.init();
  lcd.backlight();
  lcd.clear();

  servo.attach(8);

  pinMode(red,OUTPUT);
  pinMode(green,OUTPUT);
  pinMode(blue,OUTPUT);
  
  Serial.begin(9600);     
  SPI.begin();        
  mfrc522.PCD_Init();     
  Serial.println("Listo");    
}

void loop() {
  if ( ! mfrc522.PICC_IsNewCardPresent())   
    return;          
  
  if ( ! mfrc522.PICC_ReadCardSerial())     
    return;           
    
    Serial.print("UID:");       
    for (byte i = 0; i < mfrc522.uid.size; i++) { 
      if (mfrc522.uid.uidByte[i] < 0x10){   
        Serial.print(" 0");       
        }
        else{          
          Serial.print(" ");        
          }
          Serial.print(mfrc522.uid.uidByte[i], HEX);    
          LecturaUID[i]=mfrc522.uid.uidByte[i];           
          }
          
          Serial.print("\t");                      
                    
          if(comparaUID(LecturaUID, Usuario1)){
            Serial.println("Bienvenido Usuario 1");
              lcd.setCursor(0,0);
              lcd.print("Bienvenido");
              servo.write(90); 
              analogWrite(red,255);
              analogWrite(green,0);
              analogWrite(blue,0);      
          }
          
          else if(comparaUID(LecturaUID, Usuario2)){
            Serial.println("Bienvenido Usuario 2");
            lcd.setCursor(0,0);
            lcd.print("Bloqueado  ");
            servo.write(270);  
            analogWrite(red,0);
            analogWrite(green,255);
            analogWrite(blue,0);

          }
             
           else{
            Serial.println("No te conozco");              
                  
                  mfrc522.PICC_HaltA();                     
          }

}
                       
            

boolean comparaUID(byte lectura[],byte usuario[]) 
{
  for (byte i=0; i < mfrc522.uid.size; i++){    
  if(lectura[i] != usuario[i])        
    return(false);          
  }
  return(true);           
}
